# SPDX-License-Identifier: GPL-2.0
%YAML 1.2
---
$id: http://devicetree.org/schemas/arm/bcm/raspberrypi,bcm2835-firmware.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Raspberry Pi VideoCore firmware driver

maintainers:
  - Eric Anholt <eric@anholt.net>
  - Stefan Wahren <wahrenst@gmx.net>

select:
  properties:
    compatible:
      contains:
        const: raspberrypi,bcm2835-firmware

  required:
    - compatible

properties:
  compatible:
    items:
      - const: raspberrypi,bcm2835-firmware
      - const: simple-mfd

  mboxes:
    $ref: '/schemas/types.yaml#/definitions/phandle'
    description: |
      Phandle to the firmware device's Mailbox.
      (See: ../mailbox/mailbox.txt for more information)

  clocks:
    type: object

    properties:
      compatible:
        const: raspberrypi,firmware-clocks

      "#clock-cells":
        const: 1
        description: >
          The argument is the ID of the clocks contained by the
          firmware messages.

    required:
      - compatible
      - "#clock-cells"

  reset:
    type: object

    properties:
      compatible:
        const: raspberrypi,firmware-reset

      "#reset-cells":
        const: 1
        description: >
          The argument is the ID of the firmware reset line to affect.

    required:
      - compatible
      - "#reset-cells"

    additionalProperties: false

required:
  - compatible
  - mboxes

additionalProperties: false

examples:
  - |
    firmware {
        compatible = "raspberrypi,bcm2835-firmware", "simple-mfd";
        mboxes = <&mailbox>;

        firmware_clocks: clocks {
            compatible = "raspberrypi,firmware-clocks";
            #clock-cells = <1>;
        };

        reset: reset {
            compatible = "raspberrypi,firmware-reset";
            #reset-cells = <1>;
        };
    };
...
